View Javadoc

    1   /*
    2    *  Licensed to the Apache Software Foundation (ASF) under one
    3    *  or more contributor license agreements.  See the NOTICE file
    4    *  distributed with this work for additional information
    5    *  regarding copyright ownership.  The ASF licenses this file
    6    *  to you under the Apache License, Version 2.0 (the
    7    *  "License"); you may not use this file except in compliance
    8    *  with the License.  You may obtain a copy of the License at
    9    *
    10   *    http://www.apache.org/licenses/LICENSE-2.0
    11   *
    12   *  Unless required by applicable law or agreed to in writing,
    13   *  software distributed under the License is distributed on an
    14   *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    15   *  KIND, either express or implied.  See the License for the
    16   *  specific language governing permissions and limitations
    17   *  under the License.
    18   *
    19   */
    20
    21  package org.apache.mina.http.api;
    22
    23  import java.util.List;
    24  import java.util.Map;
    25
    26  /**
    27   * An HTTP request
    28   *
    29   * @author jvermillar
    30   *
    31   */
    32  public interface HttpRequest extends HttpMessage {
    33
    34      /**
    35       * Determines whether this request contains at least one parameter with the specified name
    36       *
    37       * @param name The parameter name
    38       * @return <code>true</code> if this request contains at least one parameter with the specified name
    39       */
    40      boolean containsParameter(String name);
    41
    42      /**
    43       * Returns the value of a request parameter as a String, or null if the parameter does not exist.
    44       *
    45       * If the request contained multiple parameters with the same name, this method returns the first parameter
    46       * encountered in the request with the specified name
    47       *
    48       * @param name The parameter name
    49       * @return The value
    50       */
    51      String getParameter(String name);
    52
    53      String getQueryString();
    54
    55      /**
    56       * Returns a read only {@link Map} of query parameters whose key is a {@link String} and whose value is a
    57       * {@link List} of {@link String}s.
    58       */
    59      Map<String, List<String>> getParameters();
    60
    61      /**
    62       * Return the HTTP method used for this message {@link HttpMethod}
    63       *
    64       * @return the method
    65       */
    66      HttpMethod getMethod();
    67
    68      /**
    69       * Retrurn the HTTP request path
    70       * @retrun the request path
    71       */
    72      String getRequestPath();
    73  }